// AddDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dd_ctime.h"
#include "Btrips.h"
#include "BtripSet.h"
#include "AddDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddDlg dialog


CAddDlg::CAddDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddDlg)
	//}}AFX_DATA_INIT
	time_t ltime;
	time( &ltime );
	pApp = (CBtripsApp *) AfxGetApp();
	m_pBtripSet = &pApp->m_btripSet;
	m_pBtripSet->m_pDatabase = pApp->GetDatabase();
	if (!m_pBtripSet->IsOpen())
		m_pBtripSet->Open();
	if (pApp->m_personSet.m_pDatabase == NULL)
		pApp->m_personSet.m_pDatabase = pApp->GetDatabase();
	if (!pApp->m_personSet.IsOpen())
		ASSERT(pApp->m_personSet.Open());
	pApp->m_personSet.Requery();
	if (pApp->m_divisionSet.m_pDatabase == NULL)
		pApp->m_divisionSet.m_pDatabase = pApp->GetDatabase();
	if (!pApp->m_divisionSet.IsOpen())
		ASSERT(pApp->m_divisionSet.Open());
	pApp->m_divisionSet.Requery();
	m_pBtripSet->m_CODE = _T("");
	m_pBtripSet->m_ORGANIZATION = _T("");
	m_pBtripSet->m_TARGET = _T("");
	m_pBtripSet->m_TOWN = _T("");
	m_pBtripSet->m_TRAIN = _T("");
	m_pBtripSet->m_OUTDATE = ltime;
	m_pBtripSet->m_INDATE = ltime;
}


void CAddDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddDlg)
	DDX_Control(pDX, IDC_NAME_COMBO, m_Person);
	DDX_Control(pDX, IDC_WORK_COMBO, m_WorkPlace);
	DDX_FieldText(pDX, IDC_CODE_EDIT, m_pBtripSet->m_CODE, m_pBtripSet);
	DDX_FieldText(pDX, IDC_ORGANIZATION_EDIT, m_pBtripSet->m_ORGANIZATION, m_pBtripSet);
	DDX_FieldText(pDX, IDC_TARGET_EDIT, m_pBtripSet->m_TARGET, m_pBtripSet);
	DDX_FieldText(pDX, IDC_TOWN_EDIT, m_pBtripSet->m_TOWN, m_pBtripSet);
	DDX_FieldText(pDX, IDC_TRANSPORT_EDIT, m_pBtripSet->m_TRAIN, m_pBtripSet);
	//}}AFX_DATA_MAP
	DDX_CTime(pDX, IDC_LEAVE_EDIT, m_pBtripSet->m_OUTDATE, m_pBtripSet);
	DDX_CTime(pDX, IDC_ARRIVE_EDIT, m_pBtripSet->m_INDATE, m_pBtripSet);
}


BEGIN_MESSAGE_MAP(CAddDlg, CDialog)
	//{{AFX_MSG_MAP(CAddDlg)
	ON_CBN_SELCHANGE(IDC_WORK_COMBO, OnSelchangeWorkCombo)
	ON_CBN_SELCHANGE(IDC_NAME_COMBO, OnSelchangeNameCombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddDlg message handlers

BOOL CAddDlg::OnInitDialog() 
{
	CString rcstr;
	CDialog::OnInitDialog();

	rcstr.LoadString(IDS_ADD_BTRIP);
	SetWindowText( rcstr );
	rcstr.LoadString(IDS_ADD);
	SetDlgItemText( IDOK, rcstr );
	int sel = 0;
	m_Person.ResetContent();
	if (pApp->m_personSet.IsOpen() && pApp->m_personSet.Requery())
	{
		int indx = 0;
		while (pApp->m_personSet.IsEOF() != TRUE)
		{
			m_Person.InsertString( indx, 
				pApp->m_personSet.m_NAME + 
				pApp->m_personSet.m_FIRSTNAME +
				pApp->m_personSet.m_SUBNAME );
			if (m_pBtripSet->m_ID_PERSON == pApp->m_personSet.m_ID)
				sel = indx;
			m_Person.SetItemData( indx, pApp->m_personSet.m_ID );
			indx += 1;
			pApp->m_personSet.MoveNext();
		}
	}
	m_Person.SetCurSel(sel);
	
	m_WorkPlace.ResetContent();
	sel = 0;
	if (pApp->m_divisionSet.IsOpen() && pApp->m_divisionSet.Requery())
	{
		int indx = 0;
		while (pApp->m_divisionSet.IsEOF() != TRUE)
		{
			m_WorkPlace.InsertString( indx, 
				pApp->m_divisionSet.m_TITLE );
			if (m_pBtripSet->m_ID_DIVISION == pApp->m_divisionSet.m_ID)
				sel = indx;
			m_WorkPlace.SetItemData( indx, pApp->m_divisionSet.m_ID );
			indx += 1;
			pApp->m_divisionSet.MoveNext();
		}
	}
	m_WorkPlace.SetCurSel(sel);
	UpdateData(FALSE);

//	m_pBtripSet->Edit();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddDlg::OnOK() 
{
	CString insert;

	UpdateData(TRUE);
	m_pBtripSet->m_CODE.TrimRight();
	m_pBtripSet->m_TOWN.TrimRight();
	m_pBtripSet->m_ORGANIZATION.TrimRight();
	m_pBtripSet->m_TARGET.TrimRight();
	m_pBtripSet->m_TRAIN.TrimRight();
	insert.Format(
#ifdef _ORACLE_
_T("INSERT INTO BTRIPS (ID,ID_PERSON,ID_DIVISION,CODE,\
TOWN,ORGANIZATION,TARGET,TRAIN,OUTDATE,INDATE) \
VALUES (BTRIP_IDS.NEXTVAL,%d,%d,'%s','%s','%s','%s','%s',\
TO_DATE('%s','DD/MM/YYYY'),\
TO_DATE('%s','DD/MM/YYYY'))")
#else
_T("INSERT INTO BTRIPS (ID,ID_PERSON,ID_DIVISION,CODE,\
TOWN,ORGANIZATION,TARGET,TRAIN,OUTDATE,INDATE) \
VALUES (GEN_ID(BTRIP_IDS,1),%d,%d,'%s','%s','%s','%s','%s','%s','%s')")
#endif
		, 
		m_pBtripSet->m_ID_PERSON,
		m_pBtripSet->m_ID_DIVISION,
		m_pBtripSet->m_CODE,
		m_pBtripSet->m_TOWN,
		m_pBtripSet->m_ORGANIZATION,
		m_pBtripSet->m_TARGET,
		m_pBtripSet->m_TRAIN,
#ifdef _ORACLE_
		m_pBtripSet->m_OUTDATE.Format(IDS_ORACLE_DATE_FORMAT),
		m_pBtripSet->m_INDATE.Format(IDS_ORACLE_DATE_FORMAT));
#else
		m_pBtripSet->m_OUTDATE.Format(IDS_IB_DATE_FORMAT),
		m_pBtripSet->m_INDATE.Format(IDS_IB_DATE_FORMAT));
#endif

	TRY
	{
		if (IDYES == AfxMessageBox(insert, MB_YESNO)) {
			m_pBtripSet->m_pDatabase->ExecuteSQL( insert );
			AfxMessageBox("Record successfully added !");
		}
	}
	CATCH(CDBException, e)
	{
		// The error code is in e->m_nRetCode
		AfxMessageBox(e->m_strError);
	}
	END_CATCH

	CDialog::OnOK();
}

void CAddDlg::OnSelchangeWorkCombo() 
{
	int sel = 0;
	_TCHAR filter[256];

	m_pBtripSet->m_ID_DIVISION = (long)
		m_WorkPlace.GetItemData(m_WorkPlace.GetCurSel());
	m_Person.ResetContent();
	_stprintf(filter, "WORKPLACE = %d", (int) m_pBtripSet->m_ID_DIVISION);
	pApp->m_personSet.m_strFilter = filter;
	if (pApp->m_personSet.IsOpen() && pApp->m_personSet.Requery())
	{
		int indx = 0;
		while (pApp->m_personSet.IsEOF() != TRUE)
		{
			m_Person.InsertString( indx, 
				pApp->m_personSet.m_NAME + 
				pApp->m_personSet.m_FIRSTNAME +
				pApp->m_personSet.m_SUBNAME );
			if (m_pBtripSet->m_ID_PERSON == pApp->m_personSet.m_ID)
				sel = indx;
			m_Person.SetItemData( indx, pApp->m_personSet.m_ID );
			indx += 1;
			pApp->m_personSet.MoveNext();
		}
	}
	m_Person.SetCurSel(sel);
	m_pBtripSet->m_ID_PERSON = (long)
		m_Person.GetItemData(sel);
}

void CAddDlg::OnSelchangeNameCombo() 
{
	m_pBtripSet->m_ID_PERSON = (long)
		m_Person.GetItemData(m_Person.GetCurSel());
}
