// BtripsView.cpp : implementation of the CBtripsView class
//

#include "stdafx.h"
#include "Btrips.h"

#include "AllDataSet.h"
#include "BtripsDoc.h"
#include "DebtorsDlg.h"
#include "BtripsView.h"
#include "BtripSet.h"
#include "UpdateDlg.h"
#include "AddDlg.h"
#include "PaymentAddDlg.h"
#include "PaymentsDlg.h"
#include "DivisionDlg.h"
#include "PersonDlg.h"
//#include "JournalDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBtripsView

IMPLEMENT_DYNCREATE(CBtripsView, CListView)
IMPLEMENT_PRINTABLE(CBtripsView)

BEGIN_MESSAGE_MAP(CBtripsView, CListView)
	//{{AFX_MSG_MAP(CBtripsView)
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnItemchanged)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_COMMAND(ID_OPERATIONS_LEAVING, OnLeaving)
	ON_COMMAND(ID_OPERATIONS_ARRIVING, OnArriving)
	ON_COMMAND(ID_OPERATIONS_PAYMENTS, OnPayments)
	ON_COMMAND(ID_FILTER_NOFILTER, OnFilterNofilter)
	ON_COMMAND(ID_FILTER_BYDIVISION, OnFilterBydivision)
	ON_COMMAND(ID_FILTER_BYPERIOD, OnFilterByperiod)
	ON_COMMAND(ID_FILTER_BYPERSON, OnFilterByperson)
	ON_COMMAND(ID_OPERATIONS_DELETE, OnOperationsDelete)
	ON_COMMAND(ID_INFOBASE_DIVISIONS, OnInfobaseDivisions)
	ON_COMMAND(ID_INFOBASE_PERSONS, OnInfobasePersons)
	ON_COMMAND(ID_REPORTS_DEBTORS, OnReportsDebtors)
	ON_COMMAND(ID_REPORTS_JOURNAL, OnReportsJournal)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CListView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBtripsView construction/destruction

CBtripsView::CBtripsView()
	: CListView()
{
	//{{AFX_DATA_INIT(CBtripsView)
	m_pSet = NULL;
	//}}AFX_DATA_INIT
	// TODO: add construction code here
}

CBtripsView::~CBtripsView()
{
}

void CBtripsView::DoDataExchange(CDataExchange* pDX)
{
	CListView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBtripsView)
	//}}AFX_DATA_MAP
}

BOOL CBtripsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style &= ~LVS_TYPEMASK;
	cs.style |= LVS_SHOWSELALWAYS | LVS_REPORT | LVS_NOSORTHEADER 
		| LVS_SINGLESEL;

	return CListView::PreCreateWindow(cs);
}

void CBtripsView::OnInitialUpdate()
{
	m_pSet = &GetDocument()->m_btripsSet;
	m_pSet->m_pDatabase = ((CBtripsApp *) AfxGetApp())->GetDatabase();
	CListCtrl& lc = GetListCtrl();
	CString rcstr;

//	AfxGetApp()->m_pMainWnd->SetWindowText( _T("No filter") );
	m_pSet->m_strFilter.Empty();
	CListView::OnInitialUpdate();

	rcstr.LoadString(IDS_COLUMN_1);
	lc.InsertColumn(1, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_COLUMN_2);
	lc.InsertColumn(2, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_COLUMN_3);
	lc.InsertColumn(3, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_COLUMN_4);
	lc.InsertColumn(4, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_COLUMN_5);
	lc.InsertColumn(5, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_COLUMN_6);
	lc.InsertColumn(6, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_COLUMN_7);
	lc.InsertColumn(7, rcstr, LVCFMT_LEFT, 80);

	OnUpdate(this, 1, NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CBtripsView diagnostics

#ifdef _DEBUG
void CBtripsView::AssertValid() const
{
	CListView::AssertValid();
}

void CBtripsView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CBtripsDoc* CBtripsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBtripsDoc)));
	return (CBtripsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBtripsView database support
CRecordset* CBtripsView::OnGetRecordset()
{
	return m_pSet;
}

void CBtripsView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (lHint == 0)
		return;
	if( !m_pSet->IsOpen())
		m_pSet->Open();

	CListCtrl& lc = GetListCtrl();
	lc.DeleteAllItems();
	if( m_pSet->IsOpen() && m_pSet->Requery()) {
		int indx = 0;

		if( m_pSet->IsBOF( ) )
			return;		// The recordset is empty
	    
		// Scroll to the end of the recordset, past
		// the last record, so no record is current
		while ( !m_pSet->IsEOF( ) ) {
			lc.InsertItem(indx, m_pSet->m_CODE);
			lc.SetItemText(indx, 0,
					m_pSet->m_CODE);
			lc.SetItemText(indx, 1,
					m_pSet->m_NAME);
			lc.SetItemText(indx, 2,
					m_pSet->m_FIRSTNAME);
			lc.SetItemText(indx, 3,
					m_pSet->m_TITLE);
			lc.SetItemText(indx, 4,
					m_pSet->m_TARGET);
			lc.SetItemText(indx, 5,
					m_pSet->m_TOWN);
			lc.SetItemText(indx, 6,
					m_pSet->m_TRAIN);

			lc.SetItemData( indx++, m_pSet->m_ID );
			m_pSet->MoveNext( );
		}
		lc.SetItemState( 0, 1, LVIS_SELECTED | LVIS_FOCUSED );
		nItemSelected = 0;
		m_pSet->MoveFirst( );
	}
	else 
		AfxMessageBox("Record Set can't opened or requeried !");
}

/////////////////////////////////////////////////////////////////////////////
// CBtripsView message handlers

void CBtripsView::OnItemchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNM = (NM_LISTVIEW*)pNMHDR;
	
	if ((pNM->uNewState && LVIS_SELECTED) && 
		(! pNM->uOldState && LVIS_SELECTED)) {
		nItemSelected = pNM->iItem;
	}

	*pResult = 0;
}

void CBtripsView::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CListCtrl& lc = GetListCtrl();
	CUpdateDlg m_UpdateDlg( (int)
		lc.GetItemData( nItemSelected ));
	if (IDOK == m_UpdateDlg.DoModal())
		GetDocument()->UpdateAllViews(NULL, 1, NULL);
	*pResult = 0;
}

void CBtripsView::OnLeaving() 
{
	CListCtrl& lc = GetListCtrl();
	CAddDlg m_AddDlg;
	if (IDOK == m_AddDlg.DoModal())
		GetDocument()->UpdateAllViews(NULL, 1, NULL);
}

void CBtripsView::OnArriving() 
{
//	Arriving from Bisnes Trip !
	CListCtrl& lc = GetListCtrl();
	CPaymentAddDlg m_AddDlg( (int)
		lc.GetItemData( nItemSelected ) );
	m_AddDlg.DoModal();
}

void CBtripsView::OnPayments() 
{
	CListCtrl& lc = GetListCtrl();
	CPaymentsDlg m_PaymentsDlg( (int)
		lc.GetItemData( nItemSelected ) );
	m_PaymentsDlg.DoModal();
/*
	if (IDOK == m_PaymentsDlg.DoModal())
		GetDocument()->UpdateAllViews(NULL, 1, NULL);
*/
}

void CBtripsView::RefreshFilterMenu(UINT menuID)
{
	// Locate the filter submenu
	CMenu* pFilterMenu = NULL;
	CMenu* pTopMenu = AfxGetMainWnd()->GetMenu();
	int iPos;
	for (iPos = pTopMenu->GetMenuItemCount()-1; iPos >= 0; iPos--)
	{
		CMenu* pMenu = pTopMenu->GetSubMenu(iPos);
		if (pMenu && pMenu->GetMenuItemID(0) == ID_FILTER_NOFILTER)
		{
			pFilterMenu = pMenu;
			break;
		}
	}
	ASSERT(pFilterMenu != NULL);

	for (iPos = pFilterMenu->GetMenuItemCount()-1; iPos >= 0; iPos--)
		pFilterMenu->CheckMenuItem( iPos, MF_BYPOSITION | MF_UNCHECKED );

	pFilterMenu->CheckMenuItem( menuID, MF_CHECKED );
}

void CBtripsView::OnFilterNofilter() 
{
	RefreshFilterMenu(ID_FILTER_NOFILTER);
	m_pSet->m_strFilter.Empty();
	GetDocument()->UpdateAllViews(NULL, 1, NULL);
}

void CBtripsView::OnFilterBydivision() 
{
	CDivisionDlg dvsnDlg;
	if (IDOK == dvsnDlg.DoModal()) {
		RefreshFilterMenu(ID_FILTER_BYDIVISION);
		TCHAR newFilter[256];
		_stprintf( newFilter, _T("ID_DIVISION = %d"), 
			((CBtripsApp *) AfxGetApp())->m_divisionSet.m_ID);
		m_pSet->m_strFilter = newFilter;
	}
//	else
//		m_pSet->m_strFilter.Empty();
	GetDocument()->UpdateAllViews(NULL, 1, NULL);
}

void CBtripsView::OnFilterByperiod() 
{
	RefreshFilterMenu(ID_FILTER_BYPERIOD);
	GetDocument()->UpdateAllViews(NULL, 1, NULL);
}

void CBtripsView::OnFilterByperson() 
{
	CPersonDlg prsnDlg;
	if (IDOK == prsnDlg.DoModal()) {
		RefreshFilterMenu(ID_FILTER_BYPERSON);
		TCHAR newFilter[256];
		_stprintf( newFilter, _T("ID_PERSON = %d"), 
			((CBtripsApp *) AfxGetApp())->m_personSet.m_ID);
		m_pSet->m_strFilter = newFilter;
	}
//	else
//		m_pSet->m_strFilter.Empty();
	GetDocument()->UpdateAllViews(NULL, 1, NULL);
}

void CBtripsView::OnOperationsDelete() 
{
	CString del_stmt;
	CListCtrl& lc = GetListCtrl();

#ifdef _ORACLE_
	del_stmt.Format(_T("BEGIN DELETE_BTRIP(%d); END;"),
		lc.GetItemData( nItemSelected ));
#else
	del_stmt.Format(_T("EXECUTE PROCEDURE DELETE_BTRIP %d"),
		lc.GetItemData( nItemSelected ));
#endif
	TRY
	{
		if (IDYES == AfxMessageBox( del_stmt, MB_YESNO )) {
			m_pSet->m_pDatabase->ExecuteSQL( del_stmt );
			AfxMessageBox("Record successfully deleted !");
			GetDocument()->UpdateAllViews(NULL, 1, NULL);
		}
	}
	CATCH(CDBException, e)
	{
		// The error code is in e->m_nRetCode
		AfxMessageBox(e->m_strError);
	}
	END_CATCH
}

void CBtripsView::OnInfobaseDivisions() 
{
	CDivisionDlg dvsnDlg;
	dvsnDlg.DoModal();
}

void CBtripsView::OnInfobasePersons() 
{
	CPersonDlg prsnDlg;
	prsnDlg.DoModal();
}

void CBtripsView::OnReportsDebtors() 
{
	m_debtorsDlg.Create(CDebtorsDlg::IDD, this);
}

void CBtripsView::OnReportsJournal() 
{
//	CJournalDlg jrnlDlg;
//	jrnlDlg.DoModal();
}
