// DebtorsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "btrips.h"
#include "DebtorsSet.h"
#include "DebtorsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDebtorsDlg dialog


CDebtorsDlg::CDebtorsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDebtorsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDebtorsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	CBtripsApp *pApp = (CBtripsApp *) AfxGetApp();
	m_pDebtorsSet = new CDebtorsSet();
	m_pDebtorsSet->m_pDatabase = pApp->GetDatabase();
}

CDebtorsDlg::~CDebtorsDlg()
{
	delete m_pDebtorsSet;
}

void CDebtorsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDebtorsDlg)
	DDX_Control(pDX, IDC_DEBTORS_LIST, m_debtors);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDebtorsDlg, CDialog)
	//{{AFX_MSG_MAP(CDebtorsDlg)
	ON_BN_CLICKED(IDC_PREVIEW_BUTTON, OnPreviewButton)
	ON_BN_CLICKED(IDC_PRINT_BUTTON, OnPrintButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDebtorsDlg message handlers

BOOL CDebtorsDlg::OnInitDialog() 
{
	_TCHAR balance[256];
	CString rcstr;
	CDialog::OnInitDialog();

	rcstr.LoadString(IDS_PERSON_NAME);
	m_debtors.InsertColumn(1, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_PERSON_FIRSTNAME);
	m_debtors.InsertColumn(2, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_DIVISION_TITLE);
	m_debtors.InsertColumn(3, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_BALANCE);
	m_debtors.InsertColumn(3, rcstr, LVCFMT_LEFT, 80);
	if (!m_pDebtorsSet->IsOpen())
		m_pDebtorsSet->Open();
	m_pDebtorsSet->Requery();
	m_debtors.DeleteAllItems();
	int indx = 0;
	while (m_pDebtorsSet->IsEOF() != TRUE)
	{
		m_debtors.InsertItem( indx, m_pDebtorsSet->m_NAME);
		m_debtors.SetItemText( indx, 0,	m_pDebtorsSet->m_NAME);
		m_debtors.SetItemText( indx, 1, m_pDebtorsSet->m_FIRSTNAME);
		m_debtors.SetItemText( indx, 2, m_pDebtorsSet->m_TITLE);
		_stprintf( balance, "%d",(int) m_pDebtorsSet->m_BALANCE);
		m_debtors.SetItemText( indx, 3, balance);
		indx += 1;
		m_pDebtorsSet->MoveNext();
	}
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDebtorsDlg::OnPreviewButton() 
{
	m_preview.ShowPrintPreviewFromDialog(this, &m_debtors);
}

void CDebtorsDlg::OnPrintButton() 
{
	m_preview.DoPrintFromDialog(this, &m_debtors);
}

void CDebtorsDlg::OnCancel() 
{
//	CDialog::OnCancel();
	DestroyWindow();
}
