// DebtorsSet.cpp : implementation file
//

#include "stdafx.h"
#include "btrips.h"
#include "DebtorsSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDebtorsSet

IMPLEMENT_DYNAMIC(CDebtorsSet, CRecordset)

CDebtorsSet::CDebtorsSet(CDatabase* pdb)
	: CRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CDebtorsSet)
	//}}AFX_FIELD_INIT
	m_ID = 0;
	m_NAME = _T("");
	m_FIRSTNAME = _T("");
	m_TITLE = _T("");
	m_BALANCE = 0;
	m_nFields = 5;
	m_nDefaultType = snapshot;
}


CString CDebtorsSet::GetDefaultConnect()
{
	return _T("ODBC;DSN=IB_Btrip");
}

CString CDebtorsSet::GetDefaultSQL()
{
	CTime t = CTime::GetCurrentTime();
	CTime bt(t.GetYear(), t.GetMonth(), 1, 0, 0, 0);
	CTime et = LastDayOfMonth(t);
	CString stmt;
	stmt.Format(
#ifdef _ORACLE_
_T("SELECT DISTINCT b.id_person, P.Name, P.FirstName, D.Title, \
 BALANCE(b.id_person, TO_DATE('%s','DD/MM/YYYY')) Balance \
 FROM Btrips B, Divisions D, Persons P \
 WHERE p.id = b.id_person AND d.id = b.id_division AND \
 BALANCE(b.id_person, TO_DATE('%s','DD/MM/YYYY')) != 0")
#else
_T("SELECT DISTINCT b.id_person, P.Name, P.FirstName, D.Title, \
 BALANCE(b.id_person, '%s') Balance \
 FROM Btrips B, Divisions D, Persons P \
 WHERE p.id = b.id_person AND d.id = b.id_division AND \
 BALANCE(b.id_person, '%s') != 0")
#endif
		, 
#ifdef _ORACLE_
		et.Format(IDS_ORACLE_DATE_FORMAT),
		et.Format(IDS_ORACLE_DATE_FORMAT));
#else
		et.Format(IDS_IB_DATE_FORMAT),
		et.Format(IDS_IB_DATE_FORMAT));
#endif
	return stmt;
}

void CDebtorsSet::DoFieldExchange(CFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CDebtorsSet)
	pFX->SetFieldType(CFieldExchange::outputColumn);
	//}}AFX_FIELD_MAP
	RFX_Long(pFX, _T("[ID]"), m_ID);
	RFX_Text(pFX, _T("[NAME]"), m_NAME);
	RFX_Text(pFX, _T("[FIRSTNAME]"), m_FIRSTNAME);
	RFX_Text(pFX, _T("[TITLE]"), m_TITLE);
	RFX_Long(pFX, _T("[BALANCE]"), m_BALANCE);
}

/////////////////////////////////////////////////////////////////////////////
// CDebtorsSet diagnostics

#ifdef _DEBUG
void CDebtorsSet::AssertValid() const
{
	CRecordset::AssertValid();
}

void CDebtorsSet::Dump(CDumpContext& dc) const
{
	CRecordset::Dump(dc);
}
#endif //_DEBUG
