CREATE TABLE Divisions
(
 ID NUMBER NOT NULL PRIMARY KEY,
 Title char (80)
);

CREATE TABLE Persons
(
 ID NUMBER NOT NULL PRIMARY KEY,
 Name char (20),
 FirstName char (20),
 SubName char (20),
 WorkPlace NUMBER NOT NULL,
 Status char (30),
 WorkTime NUMBER,
 FOREIGN KEY (WorkPlace) REFERENCES Divisions (ID)
);

CREATE TABLE Btrips
(
 ID NUMBER NOT NULL PRIMARY KEY,
 ID_Person NUMBER NOT NULL,
 ID_Division NUMBER NOT NULL,
 Code char (10),
 Town char (30),
 Organization char (30),
 Target char (30),
 Train char (30),
 OutDate DATE, InDate DATE,
 OutDateFact DATE, InDateFact DATE,
 Letter char (20),
 Closed char (1),
 FOREIGN KEY (ID_Person) REFERENCES Persons (ID),
 FOREIGN KEY (ID_Division) REFERENCES Divisions (ID)
);

CREATE TABLE PayTypes
(
 ID NUMBER NOT NULL PRIMARY KEY,
 Title CHAR (20)
);

CREATE TABLE Payments
(
 ID NUMBER NOT NULL PRIMARY KEY,
 ID_Btrip NUMBER,
 PayType NUMBER,
 PayDate DATE,
 PaySum NUMBER,
 FOREIGN KEY (ID_Btrip) REFERENCES Btrips (ID),
 FOREIGN KEY (PayType) REFERENCES PayTypes (ID)
);

CREATE SEQUENCE Btrip_IDs;
CREATE SEQUENCE Person_IDs;
CREATE SEQUENCE Division_IDs;
CREATE SEQUENCE Payment_IDs;
