// PaymentAddDlg.cpp : implementation file
//

#include "stdafx.h"
#include "btrips.h"
#include "PaymentAddDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPaymentAddDlg dialog


CPaymentAddDlg::CPaymentAddDlg(int btrip_id, CWnd* pParent /*=NULL*/)
	: CDialog(CPaymentAddDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPaymentAddDlg)
	//}}AFX_DATA_INIT
	time_t ltime;
	time( &ltime );
	btrip = btrip_id;
	CBtripsApp *pApp = (CBtripsApp *) AfxGetApp();
	m_pPaymentSet = &pApp->m_paymentSet;
	m_pPaymentSet->m_pDatabase = pApp->GetDatabase();
	if (! m_pPaymentSet->IsOpen()) 
		m_pPaymentSet->Open();
	m_payTypeSet.m_pDatabase = pApp->GetDatabase();
	m_pPaymentSet->m_PAYDATE = ltime;
	if (! m_payTypeSet.IsOpen()) 
		m_payTypeSet.Open();
}


void CPaymentAddDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPaymentAddDlg)
	DDX_Control(pDX, IDC_PAYMENT_TYPE_COMBO, m_paymentTypes);
	//}}AFX_DATA_MAP
	DDX_FieldText(pDX, IDC_PAYMENTSUM_EDIT, m_pPaymentSet->m_PAYSUM, m_pPaymentSet);
	DDX_CTime(pDX, IDC_PAYMENTDATE_EDIT, m_pPaymentSet->m_PAYDATE, m_pPaymentSet);
}


BEGIN_MESSAGE_MAP(CPaymentAddDlg, CDialog)
	//{{AFX_MSG_MAP(CPaymentAddDlg)
	ON_CBN_SELCHANGE(IDC_PAYMENT_TYPE_COMBO, OnSelchangePaymentTypeCombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPaymentAddDlg message handlers

BOOL CPaymentAddDlg::OnInitDialog() 
{
	CString rcstr;
	CDialog::OnInitDialog();
	
	rcstr.LoadString(IDS_ADD_PAYMENT);
	SetWindowText( rcstr );
	rcstr.LoadString(IDS_ADD);
	SetDlgItemText( IDOK, rcstr );
	m_paymentTypes.ResetContent();
	if (m_payTypeSet.IsOpen() && m_payTypeSet.Requery())
	{
		int indx = 0;
		while (m_payTypeSet.IsEOF() != TRUE)
		{
			m_paymentTypes.InsertString( indx, 
				m_payTypeSet.m_TITLE );
			m_paymentTypes.SetItemData( indx, m_payTypeSet.m_ID );
			indx += 1;
			m_payTypeSet.MoveNext();
		}
	}
	else
		AfxMessageBox(_T("Payments Type Database Open Error !"));
	m_paymentTypes.SetCurSel(0);
	m_pPaymentSet->m_PAYTYPE = (long) m_paymentTypes.GetItemData(0);
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPaymentAddDlg::OnSelchangePaymentTypeCombo() 
{
	m_pPaymentSet->m_PAYTYPE = (long)
		m_paymentTypes.GetItemData(m_paymentTypes.GetCurSel());
}

void CPaymentAddDlg::OnOK() 
{
	CString insert;

	UpdateData(TRUE);
	insert.Format(
#ifdef _ORACLE_
_T("INSERT INTO PAYMENTS (ID,ID_BTRIP,PAYTYPE,\
PAYDATE,PAYSUM) \
VALUES (PAYMENT_IDS.NEXTVAL,%d,%d,\
TO_DATE('%s','DD/MM/YYYY'),%d)")
#else
_T("INSERT INTO PAYMENTS (ID,ID_BTRIP,PAYTYPE,\
PAYDATE,PAYSUM) \
VALUES (GEN_ID(PAYMENT_IDS,1),%d,%d,'%s',%d)")
#endif
		, 
		btrip,
		m_pPaymentSet->m_PAYTYPE,
#ifdef _ORACLE_
		m_pPaymentSet->m_PAYDATE.Format(IDS_ORACLE_DATE_FORMAT),
#else
		m_pPaymentSet->m_PAYDATE.Format(IDS_IB_DATE_FORMAT),
#endif
		m_pPaymentSet->m_PAYSUM);

	TRY
	{
		if (IDYES == AfxMessageBox(insert, MB_YESNO)) {
			m_pPaymentSet->m_pDatabase->ExecuteSQL( insert );
			AfxMessageBox("Record successfully added !");
		}
	}
	CATCH(CDBException, e)
	{
		// The error code is in e->m_nRetCode
		AfxMessageBox(e->m_strError);
	}
	END_CATCH
	
	CDialog::OnOK();
}
