// PaymentsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "btrips.h"
#include "PaymentAddDlg.h"
#include "PaymentsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPaymentsDlg dialog


CPaymentsDlg::CPaymentsDlg(int btrip_id, CWnd* pParent /*=NULL*/)
	: CDialog(CPaymentsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPaymentsDlg)
	//}}AFX_DATA_INIT
	btrip = btrip_id;
	pApp = (CBtripsApp *) AfxGetApp();
	m_pPaymentsSet = &pApp->m_paymentsSet;
	m_pPaymentsSet->m_pDatabase = pApp->GetDatabase();
	_TCHAR filter[256];
	_stprintf(filter, "ID_BTRIP = %d", btrip_id);
	m_pPaymentsSet->m_strFilter = filter;
	if (!m_pPaymentsSet->IsOpen())
		m_pPaymentsSet->Open();
	m_pPaymentsSet->Requery();
}


void CPaymentsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPaymentsDlg)
	DDX_Control(pDX, IDC_PAYMENTS_LIST, m_Payments);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPaymentsDlg, CDialog)
	//{{AFX_MSG_MAP(CPaymentsDlg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_PAYMENTS_LIST, OnPaymentsListItemchanged)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CPaymentsDlg::GetPaymens()
{
	_TCHAR paySum[256];
	if (!m_pPaymentsSet->IsOpen())
		m_pPaymentsSet->Open();
	m_pPaymentsSet->Requery();
	m_Payments.DeleteAllItems();
	int indx = 0;
	while (m_pPaymentsSet->IsEOF() != TRUE)
	{
		m_Payments.InsertItem( indx, 
			m_pPaymentsSet->m_PAYDATE.Format(IDS_DATE_LOCALE));
		m_Payments.SetItemText( indx, 0,
					m_pPaymentsSet->m_PAYDATE.Format(IDS_DATE_LOCALE));
		_stprintf( paySum, "%d", (int) m_pPaymentsSet->m_PAYSUM);
		m_Payments.SetItemText( indx, 1, paySum);
		m_Payments.SetItemText( indx, 2, m_pPaymentsSet->m_PAYTYPETITLE);
		m_Payments.SetItemData( indx, m_pPaymentsSet->m_ID );
		indx += 1;
		m_pPaymentsSet->MoveNext();
	}
	m_Payments.SetItemState( 0, 1, LVIS_SELECTED | LVIS_FOCUSED );
	nItemSelected = 0;
}
/////////////////////////////////////////////////////////////////////////////
// CPaymentsDlg message handlers

BOOL CPaymentsDlg::OnInitDialog() 
{
	CString rcstr;
	CDialog::OnInitDialog();

	rcstr.LoadString(IDS_PAYMENTS_1);
	m_Payments.InsertColumn(1, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_PAYMENTS_2);
	m_Payments.InsertColumn(2, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_PAYMENTS_3);
	m_Payments.InsertColumn(3, rcstr, LVCFMT_LEFT, 80);
	GetPaymens();
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPaymentsDlg::OnPaymentsListItemchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNM = (NM_LISTVIEW*)pNMHDR;
	
	if ((pNM->uNewState && LVIS_SELECTED) && 
		(! pNM->uOldState && LVIS_SELECTED))
		nItemSelected = pNM->iItem;
	
	*pResult = 0;
}

void CPaymentsDlg::OnAddButton() 
{
	CPaymentAddDlg m_AddDlg(btrip);
	if (IDOK == m_AddDlg.DoModal()) {
		GetPaymens();
		UpdateData(FALSE);
	}
}

void CPaymentsDlg::OnDeleteButton() 
{
	CString del_stmt;

/*
	del_stmt.Format(_T("DELETE FROM PAYMENTS WHERE ID = %d"),
		m_Payments.GetItemData( nItemSelected ));
*/
#ifdef _ORACLE_
	del_stmt.Format(_T("{ CALL DELETE_PAYMENT(%d) }"),
		m_Payments.GetItemData( nItemSelected ));
#else
	del_stmt.Format(_T("EXECUTE PROCEDURE DELETE_PAYMENT %d"),
		m_Payments.GetItemData( nItemSelected ));
#endif
	TRY
	{
		if (IDYES == AfxMessageBox( del_stmt, MB_YESNO )) {
			m_pPaymentsSet->m_pDatabase->ExecuteSQL( del_stmt );
			AfxMessageBox("Record successfully deleted !");
			GetPaymens();
			UpdateData(FALSE);
		}
	}
	CATCH(CDBException, e)
	{
		// The error code is in e->m_nRetCode
		AfxMessageBox(e->m_strError);
	}
	END_CATCH
}
