// PersonAddDlg.cpp : implementation file
//

#include "stdafx.h"
#include "btrips.h"
#include "PersonAddDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPersonAddDlg dialog


CPersonAddDlg::CPersonAddDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPersonAddDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPersonAddDlg)
	//}}AFX_DATA_INIT
	pApp = (CBtripsApp *) AfxGetApp();
	m_pPersonSet = &pApp->m_personSet;
	m_pPersonSet->m_pDatabase = pApp->GetDatabase();
	if (! m_pPersonSet->IsOpen()) 
		m_pPersonSet->Open();
	if (pApp->m_divisionSet.m_pDatabase == NULL)
		pApp->m_divisionSet.m_pDatabase = pApp->GetDatabase();
	if (!pApp->m_divisionSet.IsOpen())
		ASSERT(pApp->m_divisionSet.Open());
}


void CPersonAddDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPersonAddDlg)
	DDX_Control(pDX, IDC_WORK_COMBO, m_WorkPlace);
	DDX_FieldText(pDX, IDC_FIRSTNAME_EDIT, m_pPersonSet->m_FIRSTNAME, m_pPersonSet);
	DDX_FieldText(pDX, IDC_NAME_EDIT, m_pPersonSet->m_NAME, m_pPersonSet);
	DDX_FieldText(pDX, IDC_STATUS_EDIT, m_pPersonSet->m_STATUS, m_pPersonSet);
	DDX_FieldText(pDX, IDC_SUBNAME_EDIT, m_pPersonSet->m_SUBNAME, m_pPersonSet);
	DDX_FieldText(pDX, IDC_WORKTIME_EDIT, m_pPersonSet->m_WORKTIME, m_pPersonSet);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPersonAddDlg, CDialog)
	//{{AFX_MSG_MAP(CPersonAddDlg)
	ON_CBN_SELCHANGE(IDC_WORK_COMBO, OnSelchangeWorkCombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPersonAddDlg message handlers

BOOL CPersonAddDlg::OnInitDialog() 
{
	CString rcstr;
	CDialog::OnInitDialog();
	
	rcstr.LoadString(IDS_ADD_PERSON);
	SetWindowText( rcstr );
	rcstr.LoadString(IDS_ADD);
	SetDlgItemText( IDOK, rcstr );
	m_WorkPlace.ResetContent();
	int sel = 0;
	if (pApp->m_divisionSet.IsOpen() && pApp->m_divisionSet.Requery())
	{
		int indx = 0;
		while (pApp->m_divisionSet.IsEOF() != TRUE)
		{
			m_WorkPlace.InsertString( indx, 
				pApp->m_divisionSet.m_TITLE );
			if (m_pPersonSet->m_WORKPLACE == pApp->m_divisionSet.m_ID)
				sel = indx;
			m_WorkPlace.SetItemData( indx, pApp->m_divisionSet.m_ID );
			indx += 1;
			pApp->m_divisionSet.MoveNext();
		}
	}
	m_WorkPlace.SetCurSel(sel);
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPersonAddDlg::OnOK() 
{
	CString insert;

	UpdateData(TRUE);
	m_pPersonSet->m_NAME.TrimRight();
	m_pPersonSet->m_FIRSTNAME.TrimRight();
	m_pPersonSet->m_SUBNAME.TrimRight();
	m_pPersonSet->m_STATUS.TrimRight();
	insert.Format(
#ifdef _ORACLE_
_T("INSERT INTO PERSONS (ID, NAME, FIRSTNAME, SUBNAME, STATUS, \
WORKTIME, WORKPLACE) \
VALUES (PERSON_IDS.NEXTVAL,'%s','%s','%s','%s',%d,%d)")
#else
_T("INSERT INTO PERSONS (ID, NAME, FIRSTNAME, SUBNAME, STATUS, \
WORKTIME, WORKPLACE) \
VALUES (GEN_ID(PERSON_IDS,1),'%s','%s','%s','%s',%d,%d)")
#endif
		, 
		m_pPersonSet->m_NAME,
		m_pPersonSet->m_FIRSTNAME,
		m_pPersonSet->m_SUBNAME,
		m_pPersonSet->m_STATUS,
		m_pPersonSet->m_WORKTIME,
		m_pPersonSet->m_WORKPLACE
	);

	TRY
	{
		if (IDYES == AfxMessageBox(insert, MB_YESNO)) {
			m_pPersonSet->m_pDatabase->ExecuteSQL( insert );
			AfxMessageBox("Record successfully added !");
		}
	}
	CATCH(CDBException, e)
	{
		// The error code is in e->m_nRetCode
		AfxMessageBox(e->m_strError);
	}
	END_CATCH

	CDialog::OnOK();
}

void CPersonAddDlg::OnSelchangeWorkCombo() 
{
	m_pPersonSet->m_WORKPLACE = (long)
		m_WorkPlace.GetItemData(m_WorkPlace.GetCurSel());
}
