// PersonDlg.cpp : implementation file
//

#include "stdafx.h"
#include "btrips.h"
#include "PersonAddDlg.h"
#include "PersonUpdateDlg.h"
#include "PersonDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPersonDlg dialog


CPersonDlg::CPersonDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPersonDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPersonDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	pApp = (CBtripsApp *) AfxGetApp();
	if (pApp->m_divisionSet.m_pDatabase == NULL)
		pApp->m_divisionSet.m_pDatabase = pApp->GetDatabase();
	if (!pApp->m_divisionSet.IsOpen())
		ASSERT(pApp->m_divisionSet.Open());
	pApp->m_divisionSet.Requery();
	m_pPrsnSet = &pApp->m_personSet;
	m_pPrsnSet->m_pDatabase = pApp->GetDatabase();
	if (!m_pPrsnSet->IsOpen())
		m_pPrsnSet->Open();
	_TCHAR filter[256];
	_stprintf(filter, "WORKPLACE = %d", (int) pApp->m_divisionSet.m_ID);
	m_pPrsnSet->m_strFilter = filter;
	m_pPrsnSet->Requery();
}


void CPersonDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPersonDlg)
	DDX_Control(pDX, IDC_WORK_COMBO, m_WorkPlace);
	DDX_Control(pDX, IDC_PERSON_LIST, m_personsList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPersonDlg, CDialog)
	//{{AFX_MSG_MAP(CPersonDlg)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_PERSON_LIST, OnItemchangedPersonList)
	ON_CBN_SELCHANGE(IDC_WORK_COMBO, OnSelchangeWorkCombo)
	ON_BN_CLICKED(IDC_ADD_BUTTON, OnAddButton)
	ON_NOTIFY(NM_DBLCLK, IDC_PERSON_LIST, OnDblclkPersonList)
	ON_BN_CLICKED(IDC_DELETE_BUTTON, OnDeleteButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPersonDlg message handlers

void CPersonDlg::OnItemchangedPersonList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNM = (NM_LISTVIEW*)pNMHDR;
	
	if ((pNM->uNewState && LVIS_SELECTED) && 
		(! pNM->uOldState && LVIS_SELECTED))
		nItemSelected = pNM->iItem;
	
	*pResult = 0;
}

BOOL CPersonDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString rcstr;

	int division = pApp->m_divisionSet.m_ID;
	int sel = 0;
	m_WorkPlace.ResetContent();
	if (pApp->m_divisionSet.IsOpen() && pApp->m_divisionSet.Requery())
	{
		int indx = 0;
		while (pApp->m_divisionSet.IsEOF() != TRUE)
		{
			m_WorkPlace.InsertString( indx, 
				pApp->m_divisionSet.m_TITLE );
			if (division == pApp->m_divisionSet.m_ID)
				sel = indx;
			m_WorkPlace.SetItemData( indx, pApp->m_divisionSet.m_ID );
			indx += 1;
			pApp->m_divisionSet.MoveNext();
		}
	}
	m_WorkPlace.SetCurSel(sel);

	rcstr.LoadString(IDS_PERSON_NAME);
	m_personsList.InsertColumn(1, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_PERSON_FIRSTNAME);
	m_personsList.InsertColumn(2, rcstr, LVCFMT_LEFT, 80);
	rcstr.LoadString(IDS_PERSON_SUBNAME);
	m_personsList.InsertColumn(3, rcstr, LVCFMT_LEFT, 80);
	m_personsList.DeleteAllItems();
	int indx = 0;
	while (m_pPrsnSet->IsEOF() != TRUE)
	{
		m_personsList.InsertItem( indx, 
					m_pPrsnSet->m_NAME);
		m_personsList.SetItemText( indx, 0,
					m_pPrsnSet->m_NAME);
		m_personsList.SetItemText( indx, 1,
					m_pPrsnSet->m_FIRSTNAME);
		m_personsList.SetItemText( indx, 2,
					m_pPrsnSet->m_SUBNAME);
		m_personsList.SetItemData( indx, m_pPrsnSet->m_ID );
		indx += 1;
		m_pPrsnSet->MoveNext();
	}
	m_personsList.SetItemState( 0, 1, LVIS_SELECTED | LVIS_FOCUSED );
	nItemSelected = 0;
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPersonDlg::OnOK() 
{
	m_pPrsnSet->m_ID = m_personsList.GetItemData( nItemSelected );
	
	CDialog::OnOK();
}

void CPersonDlg::OnSelchangeWorkCombo() 
{
	int sel = 0;
	_TCHAR filter[256];
	int division = m_WorkPlace.GetItemData(m_WorkPlace.GetCurSel());
	_stprintf(filter, "WORKPLACE = %d", division);
	m_pPrsnSet->m_strFilter = filter;
	if (m_pPrsnSet->IsOpen() && m_pPrsnSet->Requery())
	{
		int indx = 0;
		m_personsList.DeleteAllItems();
		while (m_pPrsnSet->IsEOF() != TRUE)
		{
			m_personsList.InsertItem( indx, 
						m_pPrsnSet->m_NAME);
			m_personsList.SetItemText( indx, 0,
						m_pPrsnSet->m_NAME);
			m_personsList.SetItemText( indx, 1,
						m_pPrsnSet->m_FIRSTNAME);
			m_personsList.SetItemText( indx, 2,
						m_pPrsnSet->m_SUBNAME);
			m_personsList.SetItemData( indx, m_pPrsnSet->m_ID );
			indx += 1;
			m_pPrsnSet->MoveNext();
		}
		m_personsList.SetItemState( 0, 1, LVIS_SELECTED | LVIS_FOCUSED );
		nItemSelected = 0;
	}
}

void CPersonDlg::OnAddButton() 
{
	CPersonAddDlg m_AddDlg;
	if (IDOK == m_AddDlg.DoModal()) {
		OnSelchangeWorkCombo();
		UpdateData(FALSE);
	}
}

void CPersonDlg::OnDblclkPersonList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CPersonUpdateDlg m_UpdateDlg( (int)
		m_personsList.GetItemData( nItemSelected ));
	if (IDOK == m_UpdateDlg.DoModal())
		OnSelchangeWorkCombo();
	*pResult = 0;
}

void CPersonDlg::OnDeleteButton() 
{
	CString del_stmt;

#ifdef _ORACLE_
	del_stmt.Format(_T("BEGIN DELETE_PERSON(%d); END;"),
		m_personsList.GetItemData( nItemSelected ));
#else
	del_stmt.Format(_T("EXECUTE PROCEDURE DELETE_PERSON %d"),
		m_personsList.GetItemData( nItemSelected ));
#endif
	TRY
	{
		if (IDYES == AfxMessageBox( del_stmt, MB_YESNO )) {
			m_pPrsnSet->m_pDatabase->ExecuteSQL( del_stmt );
			AfxMessageBox("Record successfully deleted !");
			OnSelchangeWorkCombo();
		}
	}
	CATCH(CDBException, e)
	{
		// The error code is in e->m_nRetCode
		AfxMessageBox(e->m_strError);
	}
	END_CATCH
}
