// PersonUpdateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "btrips.h"
#include "PersonUpdateDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPersonUpdateDlg dialog


CPersonUpdateDlg::CPersonUpdateDlg(int person_id, CWnd* pParent /*=NULL*/)
	: CDialog(CPersonUpdateDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPersonUpdateDlg)
	//}}AFX_DATA_INIT
	pApp = (CBtripsApp *) AfxGetApp();
	m_pPersonSet = &pApp->m_personSet;
	m_pPersonSet->m_pDatabase = pApp->GetDatabase();
	_TCHAR filter[256];
	_stprintf(filter, "ID = %d", person_id);
	m_pPersonSet->m_strFilter = filter;
	if (! m_pPersonSet->IsOpen()) 
		m_pPersonSet->Open();
	m_pPersonSet->Requery();
	if (pApp->m_divisionSet.m_pDatabase == NULL)
		pApp->m_divisionSet.m_pDatabase = pApp->GetDatabase();
	if (!pApp->m_divisionSet.IsOpen())
		ASSERT(pApp->m_divisionSet.Open());
}


void CPersonUpdateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPersonUpdateDlg)
	DDX_Control(pDX, IDC_WORK_COMBO, m_WorkPlace);
	DDX_FieldText(pDX, IDC_FIRSTNAME_EDIT, m_pPersonSet->m_FIRSTNAME, m_pPersonSet);
	DDX_FieldText(pDX, IDC_NAME_EDIT, m_pPersonSet->m_NAME, m_pPersonSet);
	DDX_FieldText(pDX, IDC_STATUS_EDIT, m_pPersonSet->m_STATUS, m_pPersonSet);
	DDX_FieldText(pDX, IDC_SUBNAME_EDIT, m_pPersonSet->m_SUBNAME, m_pPersonSet);
	DDX_FieldText(pDX, IDC_WORKTIME_EDIT, m_pPersonSet->m_WORKTIME, m_pPersonSet);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPersonUpdateDlg, CDialog)
	//{{AFX_MSG_MAP(CPersonUpdateDlg)
	ON_CBN_SELCHANGE(IDC_WORK_COMBO, OnSelchangeWorkCombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPersonUpdateDlg message handlers

BOOL CPersonUpdateDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_WorkPlace.ResetContent();
	int sel = 0;
	if (pApp->m_divisionSet.IsOpen() && pApp->m_divisionSet.Requery())
	{
		int indx = 0;
		while (pApp->m_divisionSet.IsEOF() != TRUE)
		{
			m_WorkPlace.InsertString( indx, 
				pApp->m_divisionSet.m_TITLE );
			if (m_pPersonSet->m_WORKPLACE == pApp->m_divisionSet.m_ID)
				sel = indx;
			m_WorkPlace.SetItemData( indx, pApp->m_divisionSet.m_ID );
			indx += 1;
			pApp->m_divisionSet.MoveNext();
		}
	}
	m_WorkPlace.SetCurSel(sel);
	UpdateData(FALSE);

	m_pPersonSet->Edit();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPersonUpdateDlg::OnOK() 
{
	UpdateData(TRUE);
/*
	if( !m_pPersonSet->Update( ) ) 
		AfxMessageBox("Record can't be updated !");
	else
		AfxMessageBox("Record successfully updated !");
*/
	TRY
	{
		m_pPersonSet->Update();
		AfxMessageBox("Record successfully updated !");
	}
	CATCH(CDBException, e)
	{
		// The error code is in e->m_nRetCode
		AfxMessageBox(e->m_strError);
	}
	END_CATCH

	CDialog::OnOK();
}

void CPersonUpdateDlg::OnSelchangeWorkCombo() 
{
	m_pPersonSet->m_WORKPLACE = (long)
		m_WorkPlace.GetItemData(m_WorkPlace.GetCurSel());
}

void CPersonUpdateDlg::OnCancel() 
{
	TRY
	{
		m_pPersonSet->CancelUpdate();
	}
	CATCH(CDBException, e)
	{
		// The error code is in e->m_nRetCode
		AfxMessageBox(e->m_strError);
	}
	END_CATCH

	CDialog::OnCancel();
}
