// UpdateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dd_ctime.h"
#include "Btrips.h"
#include "BtripSet.h"
#include "UpdateDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUpdateDlg dialog


CUpdateDlg::CUpdateDlg(int btrip_id, CWnd* pParent /*=NULL*/)
	: CDialog(CUpdateDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUpdateDlg)
	//}}AFX_DATA_INIT
	pApp = (CBtripsApp *) AfxGetApp();
	m_pBtripSet = &pApp->m_btripSet;
	m_pBtripSet->m_pDatabase = pApp->GetDatabase();
	_TCHAR filter[256];
	_stprintf(filter, "ID = %d", btrip_id);
	m_pBtripSet->m_strFilter = filter;
	if (!m_pBtripSet->IsOpen())
		m_pBtripSet->Open();
	m_pBtripSet->Requery();

	_stprintf(filter, "WORKPLACE = %d", (int) m_pBtripSet->m_ID_DIVISION);
	pApp->m_personSet.m_strFilter = filter;
	if (pApp->m_personSet.m_pDatabase == NULL)
		pApp->m_personSet.m_pDatabase = pApp->GetDatabase();
	if (!pApp->m_personSet.IsOpen())
		ASSERT(pApp->m_personSet.Open());
	pApp->m_personSet.Requery();
	if (pApp->m_divisionSet.m_pDatabase == NULL)
		pApp->m_divisionSet.m_pDatabase = pApp->GetDatabase();
	if (!pApp->m_divisionSet.IsOpen())
		ASSERT(pApp->m_divisionSet.Open());
	pApp->m_divisionSet.Requery();
}


void CUpdateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUpdateDlg)
	DDX_Control(pDX, IDC_NAME_COMBO, m_Person);
	DDX_Control(pDX, IDC_WORK_COMBO, m_WorkPlace);
	DDX_FieldText(pDX, IDC_CODE_EDIT, m_pBtripSet->m_CODE, m_pBtripSet);
	DDX_FieldText(pDX, IDC_ORGANIZATION_EDIT, m_pBtripSet->m_ORGANIZATION, m_pBtripSet);
	DDX_FieldText(pDX, IDC_TARGET_EDIT, m_pBtripSet->m_TARGET, m_pBtripSet);
	DDX_FieldText(pDX, IDC_TOWN_EDIT, m_pBtripSet->m_TOWN, m_pBtripSet);
	DDX_FieldText(pDX, IDC_TRANSPORT_EDIT, m_pBtripSet->m_TRAIN, m_pBtripSet);
	//}}AFX_DATA_MAP
	DDX_CTime(pDX, IDC_LEAVE_EDIT, m_pBtripSet->m_OUTDATE, m_pBtripSet);
	DDX_CTime(pDX, IDC_ARRIVE_EDIT, m_pBtripSet->m_INDATE, m_pBtripSet);
}


BEGIN_MESSAGE_MAP(CUpdateDlg, CDialog)
	//{{AFX_MSG_MAP(CUpdateDlg)
	ON_CBN_SELCHANGE(IDC_WORK_COMBO, OnSelchangeWorkCombo)
	ON_CBN_SELCHANGE(IDC_NAME_COMBO, OnSelchangeNameCombo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUpdateDlg message handlers

BOOL CUpdateDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	int sel = 0;
	m_Person.ResetContent();
	if (pApp->m_personSet.IsOpen() && pApp->m_personSet.Requery())
	{
		int indx = 0;
		while (pApp->m_personSet.IsEOF() != TRUE)
		{
			m_Person.InsertString( indx, 
				pApp->m_personSet.m_NAME + 
				pApp->m_personSet.m_FIRSTNAME +
				pApp->m_personSet.m_SUBNAME );
			if (m_pBtripSet->m_ID_PERSON == pApp->m_personSet.m_ID)
				sel = indx;
			m_Person.SetItemData( indx, pApp->m_personSet.m_ID );
			indx += 1;
			pApp->m_personSet.MoveNext();
		}
	}
	m_Person.SetCurSel(sel);
	
	m_WorkPlace.ResetContent();
	sel = 0;
	if (pApp->m_divisionSet.IsOpen() && pApp->m_divisionSet.Requery())
	{
		int indx = 0;
		while (pApp->m_divisionSet.IsEOF() != TRUE)
		{
			m_WorkPlace.InsertString( indx, 
				pApp->m_divisionSet.m_TITLE );
			if (m_pBtripSet->m_ID_DIVISION == pApp->m_divisionSet.m_ID)
				sel = indx;
			m_WorkPlace.SetItemData( indx, pApp->m_divisionSet.m_ID );
			indx += 1;
			pApp->m_divisionSet.MoveNext();
		}
	}
	m_WorkPlace.SetCurSel(sel);
	UpdateData(FALSE);

	m_pBtripSet->Edit();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CUpdateDlg::OnOK() 
{
	UpdateData(TRUE);
	if( !m_pBtripSet->Update( ) ) 
		AfxMessageBox("Record can't be updated !");
	else
		AfxMessageBox("Record successfully updated !");

	CDialog::OnOK();
}

void CUpdateDlg::OnCancel() 
{
	m_pBtripSet->CancelUpdate();

	CDialog::OnCancel();
}

void CUpdateDlg::OnSelchangeWorkCombo() 
{
	int sel = 0;
	_TCHAR filter[256];

	m_pBtripSet->m_ID_DIVISION = (long)
		m_WorkPlace.GetItemData(m_WorkPlace.GetCurSel());
	m_Person.ResetContent();
	_stprintf(filter, "WORKPLACE = %d", (int) m_pBtripSet->m_ID_DIVISION);
	pApp->m_personSet.m_strFilter = filter;
	if (pApp->m_personSet.IsOpen() && pApp->m_personSet.Requery())
	{
		int indx = 0;
		while (pApp->m_personSet.IsEOF() != TRUE)
		{
			m_Person.InsertString( indx, 
				pApp->m_personSet.m_NAME + 
				pApp->m_personSet.m_FIRSTNAME +
				pApp->m_personSet.m_SUBNAME );
			if (m_pBtripSet->m_ID_PERSON == pApp->m_personSet.m_ID)
				sel = indx;
			m_Person.SetItemData( indx, pApp->m_personSet.m_ID );
			indx += 1;
			pApp->m_personSet.MoveNext();
		}
	}
	m_Person.SetCurSel(sel);
	m_pBtripSet->m_ID_PERSON = (long)
		m_Person.GetItemData(sel);
}

void CUpdateDlg::OnSelchangeNameCombo() 
{
	m_pBtripSet->m_ID_PERSON = (long)
		m_Person.GetItemData(m_Person.GetCurSel());
}
