CONNECT "c:\users\master\sql_apps\btrips\master.gdb"
USER "SYSDBA" password "masterkey";

CREATE TABLE DIVISIONS
(
 ID INTEGER NOT NULL PRIMARY KEY,
 TITLE CHAR (80) COLLATE WIN1251
);

CREATE TABLE PERSONS
(
 ID INTEGER NOT NULL PRIMARY KEY,
 NAME CHAR (20) COLLATE WIN1251,
 FIRSTNAME CHAR (20) COLLATE WIN1251,
 SUBNAME CHAR (20) COLLATE WIN1251,
 WORKPLACE INTEGER NOT NULL,
 STATUS CHAR (30) COLLATE WIN1251,
 WORKTIME INTEGER,
 FOREIGN KEY (WORKPLACE) REFERENCES DIVISIONS (ID)
);

CREATE TABLE BTRIPS
(
 ID INTEGER NOT NULL PRIMARY KEY,
 ID_PERSON INTEGER NOT NULL,
 ID_DIVISION INTEGER NOT NULL,
 CODE CHAR (10) COLLATE WIN1251,
 TOWN CHAR (30) COLLATE WIN1251,
 ORGANIZATION CHAR (30) COLLATE WIN1251,
 TARGET CHAR (30) COLLATE WIN1251,
 TRAIN CHAR (30) COLLATE WIN1251,
 OUTDATE DATE, INDATE DATE,
 OUTDATEFACT DATE, INDATEFACT DATE,
 LETTER CHAR (20) COLLATE WIN1251,
 CLOSED CHAR (1),
 FOREIGN KEY (ID_PERSON) REFERENCES PERSONS (ID),
 FOREIGN KEY (ID_DIVISION) REFERENCES DIVISIONS (ID)
);

CREATE TABLE PAYMENTS
(
 ID INTEGER NOT NULL PRIMARY KEY,
 ID_BTRIP INTEGER NOT NULL,
 PAYTYPE INTEGER NOT NULL,
 PAYDATE DATE,
 PAYSUM INTEGER,
 FOREIGN KEY (ID_BTRIP) REFERENCES BTRIPS (ID),
 FOREIGN KEY (PAYTYPE) REFERENCES PAYTYPES (ID)
);

/*
CREATE TABLE PAYPARTS
(
 ID_PAYMENT INTEGER NOT NULL,
 COMMENT CHAR (30) COLLATE WIN1251,
 PARTSUM INTEGER,
 FOREIGN KEY (ID_PAYMENT) REFERENCES PAYMENTS (ID)
);
*/

CREATE TABLE PAYTYPES
(
 ID INTEGER NOT NULL PRIMARY KEY,
 TITLE CHAR (20) COLLATE WIN1251
);

CREATE GENERATOR BTRIP_IDS;
CREATE GENERATOR PERSON_IDS;
CREATE GENERATOR DIVISION_IDS;
CREATE GENERATOR PAYMENT_IDS;

COMMIT;
EXIT;
