// dd_ctime.cpp : implementation of DDX_CTime
//

#include <time.h>
#include "stdafx.h"
#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// Public functions

BOOL GetCTime(HWND hWnd, CTime& time)
{
	TCHAR szWindowText[20];
	::GetWindowText(hWnd, szWindowText, 19);
	int nYear; int nMonth; int nDay;
	TCHAR* psz;
	TCHAR* pszYear;
	TCHAR* pszMonth;
	TCHAR* pszDay;

	// strip leading blanks
	for (pszDay = szWindowText;  *pszDay == ' ';  pszDay++)
	{
		if (*pszDay == 0)
			return FALSE;
	}

	for (psz = pszDay; (*psz != '/') && (*psz != 0); psz++)
	{
		if ((*psz < '0') || (*psz > '9'))
			return FALSE;
	}
	*psz = 0;

	if (_tcslen(pszDay) > 2)
		return FALSE;

	if (_tcslen(pszDay) == 0)
		return FALSE;
	else
	{
		nDay = _ttoi(pszDay);
		if (nDay > 30)
			return FALSE;
	}

	for (pszMonth = ++psz; (*psz != '/') && (*psz != 0); psz++)
	{
		if ((*psz < '0') || (*psz > '9'))
			return FALSE;
	}
	*psz = 0;

	if (_tcslen(pszMonth) > 2)
		return FALSE;

	if (_tcslen(pszMonth) == 0)
		return FALSE;
	else
	{
		nMonth = _ttoi(pszMonth);
		if (nMonth > 12)
			return FALSE;
	}

	for (pszYear = ++psz; (*psz != ' ') && (*psz != 0); psz++)
	{
		if ((*psz < '0') || (*psz > '9'))
			return FALSE;
	}
	*psz = 0;

	if (_tcslen(pszYear) != 4)
		return FALSE;
	else
		nYear = _ttoi(pszYear);

	CTime newtime( nYear, nMonth, nDay, 0, 0, 0);
	if ( newtime == NULL)
		return FALSE;
	else
		time = newtime;
	return TRUE;
}

BOOL GetCTime(CWnd* pWnd, CTime& time)
{
	ASSERT(pWnd != NULL);
	return GetCTime(pWnd->m_hWnd, time);
}

void SetCTime(HWND hWnd, CTime& time)
{
	::SetWindowText(hWnd, time.Format(IDS_DATE_LOCALE) );
}

void SetCTime(CWnd* pWnd, CTime& time)
{
	ASSERT(pWnd != NULL);
	SetCTime(pWnd->m_hWnd, time);
}

void AFXAPI DDX_CTime(CDataExchange* pDX, int nIDC, CTime& time, CRecordset* pRecordset)
{
	HWND hWndCtrl = pDX->PrepareEditCtrl(nIDC);
	if (pDX->m_bSaveAndValidate)
	{
		if (!GetCTime(hWndCtrl, time))
		{
			AfxMessageBox(IDS_INVALID_TIME);
			pDX->Fail();
		}
	}
	else
	{
		/*
		if (pRecordset->IsFieldNull(&time))
			time = CTime::GetCurrentTime();
		*/
		SetCTime(hWndCtrl, time);
	}
}

CTime LastDayOfMonth(CTime& time)
{
	int m = time.GetMonth();
	int y = time.GetYear();
	if (m >= 12) {
		m = 0;
		y += 1;
	}
	CTime t(y, m + 1, 1, 0, 0, 0);
	CTimeSpan dt(1, 0, 0, 0);
	return t - dt;
}